#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

namespace TabbedMDI {

	using System;
	using System.ComponentModel;
	using System.Drawing;
	using System.Drawing.Text;
	using System.Windows.Forms;
    using Syncfusion.Windows.Forms.Tools;

	public class Document1 : System.Windows.Forms.Form
    {
        private IContainer components;
        private System.Windows.Forms.MainMenu mainMenu;
        private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager;

        private CheckedListBox checkedListBox1;
        private Button btnDockingManager_ChangeVisibilty;

        public Document1(string docName) : base() {

            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            this.Text = docName;
        }

		~Document1()
		{
		}

        //File->Load Document Menu item handler
        protected void LoadDocument_Clicked(object sender, System.EventArgs e)
		{
            MessageBox.Show(this.Text) ;
        }

        /// <summary>
        ///    Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
			if(components != null)
				components.Dispose();
        }


        /// <summary>
        ///    Required method for Designer support - do not modify
        ///    the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Document1));
            this.mainMenu = new System.Windows.Forms.MainMenu(this.components);
            this.checkedListBox1 = new System.Windows.Forms.CheckedListBox();
            this.btnDockingManager_ChangeVisibilty = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // checkedListBox1
            // 
            this.checkedListBox1.FormattingEnabled = true;
            this.checkedListBox1.Location = new System.Drawing.Point(343, 12);
            this.checkedListBox1.Name = "checkedListBox1";
            this.checkedListBox1.Size = new System.Drawing.Size(168, 289);
            this.checkedListBox1.TabIndex = 14;
            // 
            // btnDockingManager_ChangeVisibilty
            // 
            this.btnDockingManager_ChangeVisibilty.Font = new System.Drawing.Font("Trebuchet MS", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btnDockingManager_ChangeVisibilty.ForeColor = System.Drawing.Color.Brown;
            this.btnDockingManager_ChangeVisibilty.Location = new System.Drawing.Point(263, 307);
            this.btnDockingManager_ChangeVisibilty.Name = "btnDockingManager_ChangeVisibilty";
            this.btnDockingManager_ChangeVisibilty.Size = new System.Drawing.Size(238, 43);
            this.btnDockingManager_ChangeVisibilty.TabIndex = 15;
            this.btnDockingManager_ChangeVisibilty.Text = "Show / Hide [docking window]";
            this.btnDockingManager_ChangeVisibilty.UseVisualStyleBackColor = true;
            this.btnDockingManager_ChangeVisibilty.Click += new System.EventHandler(this.btnDockingManager_ChangeVisibilty_Click);
            // 
            // Document1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(523, 516);
            this.Controls.Add(this.btnDockingManager_ChangeVisibilty);
            this.Controls.Add(this.checkedListBox1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Menu = this.mainMenu;
            this.MinimizeBox = false;
            this.Name = "Document1";
            this.ShowInTaskbar = false;
            this.Load += new System.EventHandler(this.Document1_Load);
            this.ResumeLayout(false);

		}
        private void InitializeDockingWindows()
        {
            //try
            //{
                this.dockingManager = new Syncfusion.Windows.Forms.Tools.DockingManager();
                this.dockingManager.BeginInit();
                this.dockingManager.HostControl = this;
                this.dockingManager.ThemesEnabled = true;
                // this.dockingManager.AutoHideActiveControl = true; 
                DockingManager.AnimationStep = 50;
                this.dockingManager.VisualStyle = Syncfusion.Windows.Forms.VisualStyle.Office2003;
                this.dockingManager.PersistState = false;
                this.dockingManager.DisallowFloating = false; // windows should be dockable, amir
                this.dockingManager.AutoHideInterval = 500; // To make docking panel quick in getting show/hide events (Less interval means more quick), amir               

                this.dockingManager.DockControl(checkedListBox1, this, Syncfusion.Windows.Forms.Tools.DockingStyle.Right , 300);
                this.dockingManager.SetDockLabel(checkedListBox1, ":: "+this.Text+" :Docking Panel");
                //this.dockingManager.DockControl(pnlFilter, this, DockingStyle.Bottom, 250);
                //this.dockingManager.SetDockLabel(pnlFilter, Utility.GetLocalizedText("LNAFilters", CommonVariables.CultureInfo));

                this.dockingManager.EndInit();
            //}
            //catch (Exception objException)
            //{
            //    Utility.LogException(objException);
            //}
        }

        private void Document1_Load(object sender, EventArgs e)
        {
            InitializeDockingWindows();
        }

        private void btnDockingManager_ChangeVisibilty_Click(object sender, EventArgs e)
        {
            if (this.dockingManager.GetDockVisibility(this.checkedListBox1))
            {
                this.checkedListBox1.Visible = false; //to avoid blinking before being disappeared                                                
                this.dockingManager.SetDockVisibility(this.checkedListBox1, false);
                this.dockingManager.SetAutoHideMode(checkedListBox1, true);
            }
            else
            {
                this.dockingManager.SetDockVisibility(this.checkedListBox1 , true);
                this.dockingManager.SetAutoHideMode(checkedListBox1, false);
                this.checkedListBox1.Visible = true;
            }
        }

    }
}
