#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

namespace TabbedMDI {

	using System;
	using System.ComponentModel;
	using System.Drawing;
	using System.Windows.Forms;
	using Syncfusion.Windows.Forms;
	using Microsoft.Win32;
	using Syncfusion.Windows.Forms.Tools;
	using Syncfusion.Windows.Forms.Tools.XPMenus;
	using Syncfusion.Runtime.Serialization;

	using System.Diagnostics;
	using System.Runtime.InteropServices;

    public class MainForm : System.Windows.Forms.Form 
	{
		# region Declaration
		private System.ComponentModel.IContainer components;
        private System.Windows.Forms.MainMenu mainMenu;
        protected System.Windows.Forms.StatusBar statusBar1;
		private TabbedMDIManager tabbedMDIManager;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem7;
        private System.Windows.Forms.MenuItem addDoc1;
		private System.Windows.Forms.MenuItem exitMenu;
		private MenuItem miWindow;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem4;
        private System.Windows.Forms.ImageList imageList1;
        private System.Windows.Forms.Splitter splitter1;
        private bool tabWindowsOn = false;
        
        
		#endregion

        public MainForm() 
		{
            InitializeComponent();

			tabbedMDIManager = new TabbedMDIManager();
			//this.propertyGrid1.SelectedObject = (object)this.tabbedMDIManager;
			//this.tabbedMDIManager.TabControlAdded += new TabbedMDITabControlEventHandler(tabbedMDIManager_TabControlAdded);
			//this.tabbedMDIManager.BeforeDropDownPopup += new DropDownPopupEventHandler(tabbedMDIManager_BeforePopup);
			
			#region Dynamically created menus
			this.miWindow = mainMenu.MenuItems.Add("Window");
			miWindow.MergeOrder = 6;
			miWindow.MenuItems.Add("Cascade", new System.EventHandler(this.WindowCascade_Clicked));
			miWindow.MenuItems.Add("Tile Horizontal", new System.EventHandler(this.WindowTileH_Clicked));
			miWindow.MenuItems.Add("Tile Vertical", new System.EventHandler(this.WindowTileV_Clicked));
			miWindow.MenuItems.Add("MDI Tabbed", new System.EventHandler(this.TabbedWindows_Clicked));

			// Let the TabbedMDIManager insert the Mdi Child windows list
			this.tabbedMDIManager.MdiListMenuItem = miWindow;
			#endregion
			
			#region Append menus to the standard mdi tab context menu
			ParentBarItem contextMenuItem = new ParentBarItem();
			contextMenuItem.Style = VisualStyle.Office2003;

			BarItem newDocItem = new BarItem();
			newDocItem.ImageList = this.imageList1;
			newDocItem.ImageIndex = 5;
			newDocItem.Click += new System.EventHandler(this.addDoc1_Click);
			newDocItem.Text = "Custom Item: Insert New Doc";
			newDocItem.MergeOrder = 30;
			contextMenuItem.Items.Add(newDocItem);

			BarItem exitItem = new BarItem();
			exitItem.ImageList = this.imageList1;
			exitItem.ImageIndex = 2;
			exitItem.Click += new System.EventHandler(this.FileExit_Clicked);
			exitItem.Text = "CustomItem: Exit";
			exitItem.MergeOrder = 30;
			contextMenuItem.Items.Add(exitItem);

			contextMenuItem.BeginGroupAt(newDocItem);
			
			// Items in this ParentBarItem will be merged with the standard context menu ParentBarItem of the mdi tab.
			tabbedMDIManager.ContextMenuItem = contextMenuItem;
			#endregion
        }

		# region Handlers
		// Convenient way to toggle TabbedMDI mode.
		internal bool TabbedMDIOn
		{
			get	{	return this.tabWindowsOn;	}
			set
			{
				if(!(this.tabWindowsOn == value))
				{
					this.tabWindowsOn = value;

					if(this.tabWindowsOn)
					{
						this.tabbedMDIManager.AttachToMdiContainer(this);
					}
					else
					{
						this.tabbedMDIManager.DetachFromMdiContainer(this, false); // false to not invoke the Cascade mode after detaching.
					}
				}
			}
		}


		internal TabbedMDIManager TabbedMDIManager
		{
			get{return this.tabbedMDIManager;}
		}


        //Add a document 
        private void AddDocument(Form doc) {
            doc.MdiParent = this;
            doc.Show();
        }


		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Add 2 documents
			this.addDoc1_Click(this, EventArgs.Empty);
			this.addDoc1_Click(this, EventArgs.Empty);

            this.tabbedMDIManager.TabStyle = typeof(Syncfusion.Windows.Forms.Tools.TabRendererOffice2003);
			// Turn on MDI Tabbed Documents mode.
			// Call this after loading the mdi children to restore their previous state.
            this.TabbedMDIOn = true;
            //InitializeDockingWindows();
		}
        //private void InitializeDockingWindows()
        //{
        //    try
        //    {
        //        this.DOMLNA = new Syncfusion.Windows.Forms.Tools.DockingManager();
        //        this.DOMLNA.BeginInit();
        //        this.DOMLNA.HostControl = this;
        //        this.DOMLNA.ThemesEnabled = true;
        //        // this.DOMLNA.AutoHideActiveControl = true; 
        //        DockingManager.AnimationStep = 50;
        //        this.DOMLNA.VisualStyle = Syncfusion.Windows.Forms.VisualStyle.Office2003;
        //        this.DOMLNA.PersistState = false;
        //        this.DOMLNA.DisallowFloating = false; // windows should be dockable, amir
        //        this.DOMLNA.AutoHideInterval = 500; // To make docking panel quick in getting show/hide events (Less interval means more quick), amir               

        //        this.DOMLNA.DockControl(checkedListBox1, this, Syncfusion.Windows.Forms.Tools.DockingStyle.Right, 300);
        //        //this.DOMLNA.SetDockLabel(pnlNodeFilters, Utility.GetLocalizedText("Options", CommonVariables.CultureInfo));
        //        //this.DOMLNA.DockControl(pnlFilter, this, DockingStyle.Bottom, 250);
        //        //this.DOMLNA.SetDockLabel(pnlFilter, Utility.GetLocalizedText("LNAFilters", CommonVariables.CultureInfo));

        //        this.DOMLNA.EndInit();
        //    }
        //    catch (Exception objException)
        //    {
        //        //Utility.LogException(objException);
        //    }
        //}

		private int document1Count = 0 ;

		internal void addDoc1_Click(object sender, System.EventArgs e)
		{
			
			document1Count++ ;
			Document1 doc = new Document1("Document " + document1Count.ToString());
			AddDocument(doc);
			this.tabbedMDIManager.SetTooltip(doc, "Tooltip for " + doc.Text);
		}


        //Window->Cascade Menu item handler
        protected internal void WindowCascade_Clicked(object sender, System.EventArgs e) {
			this.TabbedMDIOn = false;
            this.LayoutMdi(MdiLayout.Cascade);   
        }
	

        //Window->Tile Horizontally Menu item handler
        protected void WindowTileH_Clicked(object sender, System.EventArgs e) {
			this.TabbedMDIOn = false;
            this.LayoutMdi(MdiLayout.TileHorizontal);
        }


        //Window->Tile Vertically Menu item handler
        protected void WindowTileV_Clicked(object sender, System.EventArgs e) {
			this.TabbedMDIOn = false;
            this.LayoutMdi(MdiLayout.TileVertical);
        }


		protected internal void TabbedWindows_Clicked(object sender, System.EventArgs e)
		{
			this.TabbedMDIOn = true;
		}


		//File->Exit Menu item handler
		protected void FileExit_Clicked(object sender, System.EventArgs e) 
		{
			this.Close();
		}


		//One of the MDI Child windows has been activated
		protected void MDIChildActivated(object sender, System.EventArgs e) 
		{
			if (this.ActiveMdiChild == null) 
			{
				statusBar1.Text = "";
			} 
			else 
			{
				statusBar1.Text = this.ActiveMdiChild.Text;
			}
		}

		#endregion

        /// <summary>
        ///    Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing) 
        {
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
				this.tabbedMDIManager.Dispose();
			}
			base.Dispose( disposing );
        }

        /// <summary>
        ///    Required method for Designer support - do not modify
        ///    the contents of this method with the code editor.
        /// </summary>
        /// 
        protected void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.mainMenu = new System.Windows.Forms.MainMenu(this.components);
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.addDoc1 = new System.Windows.Forms.MenuItem();
            this.menuItem7 = new System.Windows.Forms.MenuItem();
            this.exitMenu = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.statusBar1 = new System.Windows.Forms.StatusBar();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.SuspendLayout();
            // 
            // mainMenu
            // 
            this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem2,
            this.menuItem1});
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 0;
            this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem3,
            this.menuItem7,
            this.exitMenu});
            this.menuItem2.Text = "&File";
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 0;
            this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.addDoc1});
            this.menuItem3.Text = "&New";
            // 
            // addDoc1
            // 
            this.addDoc1.Index = 0;
            this.addDoc1.MergeOrder = 20;
            this.addDoc1.Shortcut = System.Windows.Forms.Shortcut.CtrlD;
            this.addDoc1.Text = "&Document";
            this.addDoc1.Click += new System.EventHandler(this.addDoc1_Click);
            // 
            // menuItem7
            // 
            this.menuItem7.Index = 1;
            this.menuItem7.Text = "-";
            // 
            // exitMenu
            // 
            this.exitMenu.Index = 2;
            this.exitMenu.MergeOrder = 20;
            this.exitMenu.Text = "E&xit";
            this.exitMenu.Click += new System.EventHandler(this.FileExit_Clicked);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 1;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem4});
            this.menuItem1.MergeOrder = 7;
            this.menuItem1.Text = "&Help";
            this.menuItem1.Visible = false;
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 0;
            this.menuItem4.Text = "&About Syncfusion";
            this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
            // 
            // statusBar1
            // 
            this.statusBar1.Location = new System.Drawing.Point(0, 401);
            this.statusBar1.Name = "statusBar1";
            this.statusBar1.Size = new System.Drawing.Size(705, 24);
            this.statusBar1.TabIndex = 1;
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            this.imageList1.Images.SetKeyName(5, "");
            this.imageList1.Images.SetKeyName(6, "");
            this.imageList1.Images.SetKeyName(7, "");
            this.imageList1.Images.SetKeyName(8, "");
            this.imageList1.Images.SetKeyName(9, "");
            this.imageList1.Images.SetKeyName(10, "");
            this.imageList1.Images.SetKeyName(11, "");
            this.imageList1.Images.SetKeyName(12, "");
            this.imageList1.Images.SetKeyName(13, "");
            this.imageList1.Images.SetKeyName(14, "");
            this.imageList1.Images.SetKeyName(15, "");
            this.imageList1.Images.SetKeyName(16, "");
            this.imageList1.Images.SetKeyName(17, "");
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Right;
            this.splitter1.Location = new System.Drawing.Point(702, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(3, 401);
            this.splitter1.TabIndex = 11;
            this.splitter1.TabStop = false;
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(705, 425);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.statusBar1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.IsMdiContainer = true;
            this.Menu = this.mainMenu;
            this.Name = "MainForm";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Docking Mgr Minimize Problem- (Make Floating, Minimize Appliacation, Docking Rema" +
                "ins on Desktop)";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.MdiChildActivate += new System.EventHandler(this.MDIChildActivated);
            this.Load += new System.EventHandler(this.MainForm_Load);
            this.ResumeLayout(false);

		}


		#region DLL Imports
		[DllImport("user32.dll", CharSet=CharSet.Auto)]
		extern public static bool SetForegroundWindow(IntPtr hwnd);
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			// Modify this version, whenever changes are made such that the persisted state cannot be loaded anymore.
			string curVersion = "1.0";
			ValidatePersistedStateVersion(curVersion);
			StoreVersionInfo(curVersion);

			MainForm mainForm = new MainForm();

			bool bRunning = false;
			foreach ( Process p in Process.GetProcesses(System.Environment.MachineName) )
			{
				if( p.MainWindowHandle != IntPtr.Zero)
				{
					// Process name gets truncated!
					if(p.ProcessName == "TabbedMDI")
					{
						bRunning = true;
						MessageBox.Show("Activating the already open instance of TabbedMDI.exe.");
						SetForegroundWindow(p.MainWindowHandle);
						break;
					}
				}
			}
			if(!bRunning)
			{
				Application.Run(mainForm);
			}
		}


		#region VERSIONING
		static string VersionTag = "AppVersion";
		static void ValidatePersistedStateVersion(string curVersion)
		{
			// Versioning
			AppStateSerializer serializer = AppStateSerializer.GetSingleton();
			object objectOut = serializer.DeserializeObject(VersionTag);
			if(objectOut != null)
			{
				string version = (string)objectOut;
				version = version.ToLower();

				curVersion = curVersion.ToLower();

				// Persisted info is not the current version, lets lose it.
				if(version != curVersion)
					serializer.FlushSerializer();
			}
		}
		// Store the current version, so that we can validate it the next time.
		static void StoreVersionInfo(string curVersion)
		{
			AppStateSerializer serializer = AppStateSerializer.GetSingleton();
			serializer.SerializeObject(VersionTag, curVersion, true);
		}
		#endregion VERSIONING

		#region AboutForm_Logic
		DemoCommon.AboutForm aboutForm = null;
		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			aboutForm = new DemoCommon.AboutForm(AppDomain.CurrentDomain.GetAssemblies());
			aboutForm.ShowDialog();
		}
		private void AboutFormCloseBtnClicked(object sender, EventArgs e)
		{
			aboutForm.Close();
		}
		#endregion AboutForm_Logic

	}
}


